<?php

namespace Config;

use CodeIgniter\Config\BaseConfig;

class Filters extends BaseConfig {

    // Makes reading things below nicer,
    // and simpler to change out script that's used.
    public $aliases = [
        'csrf' => \CodeIgniter\Filters\CSRF::class,
        'toolbar' => \CodeIgniter\Filters\DebugToolbar::class,
        'honeypot' => \CodeIgniter\Filters\Honeypot::class,
    ];
    // Always applied before every request
    public $globals = [
        'before' => [
            //'honeypot'
            'csrf' => [
                'except' => [
                    'checkOldPass',
                    'upload_img',
                    'Api.*+', 'Table.*+',
                    'delete_breaking_news',
                    'delete_category', 'delete_subcategory', 'get_subcategory_by_category',
                    'delete_tag',
                    'delete_user_roles',
                    'delete_comment', 'delete_comment_flag',
                    'delete_notification',
                    'delete_news', 'delete_news_image',
                    'delete_live_streaming',
                    'delete_question',
                    'delete_option'
                ]
            ]
        ],
        'after' => [
            'toolbar',
        //'honeypot'
        ],
    ];
    // Works on all of a particular HTTP method
    // (GET, POST, etc) as BEFORE filters only
    //     like: 'post' => ['CSRF', 'throttle'],
    public $methods = [];
    // List filter aliases and any before/after uri patterns
    // that they should run on, like:
    //    'isLoggedIn' => ['before' => ['account/*', 'profiles/*']],
    public $filters = [];

}
