<?php

namespace App\Controllers;

use CodeIgniter\RESTful\ResourceController;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

class Table extends ResourceController {

    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger) {
        // Do Not Edit This Line
        parent::initController($request, $response, $logger);
        $this->db = \Config\Database::connect();
        $this->helpers = helper('News');
    }

    public function tag() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where = "where (id like '%" . $search . "%' OR tag_name like '%" . $search . "%')";
        }

        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_tag $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT * FROM tbl_tag $where ORDER BY $sort $order LIMIT $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $operate = '<a class="btn btn-icon btn-sm btn-primary text-white edit-data" data-id=' . $row->id . ' data-toggle="modal" data-target="#editDataModal" title="Edit"><em class="fa fa-edit"></em></a>&nbsp;&nbsp;';
            $operate .= '<a class="btn btn-icon btn-sm btn-danger text-white delete-data" data-id=' . $row->id . ' ><em class="fa fa-trash"></em></a>';

            $tempRow['id'] = $row->id;
            $tempRow['tag_name'] = $row->tag_name;
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }
    public function user_roles() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where = "where (id like '%" . $search . "%' OR tag_name like '%" . $search . "%')";
        }

        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_user_roles $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT * FROM tbl_user_roles $where ORDER BY $sort $order LIMIT $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $operate = '<a class="btn btn-icon btn-sm btn-primary text-white edit-data" data-id=' . $row->id . ' data-toggle="modal" data-target="#editDataModal" title="Edit"><em class="fa fa-edit"></em></a>&nbsp;&nbsp;';
            $operate .= '<a class="btn btn-icon btn-sm btn-danger text-white delete-data" data-id=' . $row->id . ' ><em class="fa fa-trash"></em></a>';

            $tempRow['id'] = $row->id;
            $tempRow['role'] = $row->role;
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

    public function breaking_news() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where = "where (id like '%" . $search . "%' OR title like '%" . $search . "%')";
        }

        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_breaking_news $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT * FROM tbl_breaking_news  $where  ORDER BY  $sort  $order  LIMIT  $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $con_v = '';
            $image = (!empty($row->image)) ? 'public/images/breaking_news/' . $row->image : '';
            $operate = '<a class="btn btn-icon btn-sm btn-primary text-white edit-data" data-id=' . $row->id . ' data-toggle="modal" data-target="#editDataModal" title="Edit"><em class="fa fa-edit"></em></a>&nbsp;&nbsp;';
            if ($row->content_type != 'standard_post') {
                if ($row->content_type == 'video_upload') {
                    $con_value = 'public/images/breaking_news_video/' . $row->content_value;
                    $con_v = 'public/images/breaking_news_video/' . $row->content_value;
                    $operate .= '<a class="btn btn-icon btn-sm btn-warning text-white" data-toggle="lightbox" data-title="Video" data-type="video" href="' . $con_value . '" title="view video"><em class="fas fa-eye"></em></a>&nbsp;&nbsp;';
                } else {
                    $con_value = $row->content_value;
                    $con_v = '';
                    $operate .= '<a class="btn btn-icon btn-sm btn-warning text-white" data-toggle="lightbox" data-title="Video" data-type="youtube" href="' . $con_value . '" title="view video"><em class="fas fa-eye"></em></a>&nbsp;&nbsp;';
                }
            }
            $operate .= '<a class="btn btn-icon btn-sm btn-danger text-white delete-data" data-id=' . $row->id . ' data-image="' . $image . '" data-cvalue="' . $con_v . '"><em class="fa fa-trash"></em></a>';

            $tempRow['con_v'] = $con_v;
            $tempRow['content_value'] = $con_value;
            $tempRow['image_url'] = $image;
            $tempRow['id'] = $row->id;
            $tempRow['title'] = $row->title;
            $tempRow['content'] = $row->content_type;
            $tempRow['content_type'] = str_replace('_', ' ', $row->content_type);
            $tempRow['image'] = (!empty($row->image)) ? '<a href=' . APP_URL . $image . '  data-toggle="lightbox" data-title="Image" data-gallery="gallery"><img src=' . APP_URL . $image . ' height=50, width=50 >' : 'No Image';
            $tempRow['description'] = $row->description;
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

    public function live_streaming() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where = "where (id like '%" . $search . "%' OR title like '%" . $search . "%')";
        }
        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_live_streaming $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT * FROM tbl_live_streaming  $where  ORDER BY  $sort  $order  LIMIT  $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $image = (!empty($row->image)) ? 'public/images/liveStreaming/' . $row->image : '';
            $operate = '<a class="btn btn-icon btn-sm btn-primary text-white edit-data" data-id=' . $row->id . ' data-toggle="modal" data-target="#editDataModal" title="Edit"><em class="fa fa-edit"></em></a>&nbsp;&nbsp;';
            $operate .= '<a class="btn btn-icon btn-sm btn-danger text-white delete-data" data-id=' . $row->id . ' data-image="' . $image . '"><em class="fa fa-trash"></em></a>';

            $tempRow['image_url'] = $image;
            $tempRow['id'] = $row->id;
            $tempRow['title'] = $row->title;
            $tempRow['type'] = str_replace('_', ' ', $row->type);
            $tempRow['type1'] = $row->type;
            $tempRow['url'] = $row->url;
            $tempRow['image'] = (!empty($row->image)) ? '<a href=' . APP_URL . $image . '  data-toggle="lightbox" data-title="Image" data-gallery="gallery"><img src=' . APP_URL . $image . ' height=50, width=50 >' : 'No Image';
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

    public function subcategory() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where = "where (s.id like '%" . $search . "%' OR c.category_name like '%" . $search . "%')";
        }

        $join = ' JOIN tbl_category c ON c.id = s.category_id';

        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_subcategory s $join $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT s.*, c.category_name FROM tbl_subcategory s $join $where ORDER BY $sort $order LIMIT $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $image = (!empty($row->image)) ? 'public/images/subcategory/' . $row->image : '';
            $operate = '<a class="btn btn-icon btn-sm btn-primary text-white edit-data" data-id=' . $row->id . ' data-toggle="modal" data-target="#editDataModal" title="Edit"><em class="fa fa-edit"></em></a>&nbsp;&nbsp;';
            $operate .= '<a class="btn btn-icon btn-sm btn-danger text-white delete-data" data-id=' . $row->id . ' data-image="' . $image . '"><em class="fa fa-trash"></em></a>';

            $tempRow['image_url'] = $image;
            $tempRow['id'] = $row->id;
            $tempRow['category_id'] = $row->category_id;
            $tempRow['category_name'] = $row->category_name;
            $tempRow['subcategory_name'] = $row->subcategory_name;
            $tempRow['image'] = (!empty($row->image)) ? '<a href=' . APP_URL . $image . '  data-toggle="lightbox" data-title="Image" data-gallery="gallery"><img src=' . APP_URL . $image . ' height=50, width=50 >' : 'No Image';
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

    public function category() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where = "where (id like '%" . $search . "%' OR category_name like '%" . $search . "%')";
        }
        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_category $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT * FROM tbl_category  $where  ORDER BY  $sort  $order  LIMIT  $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $image = (!empty($row->image)) ? 'public/images/category/' . $row->image : '';
            $operate = '<a class="btn btn-icon btn-sm btn-primary text-white edit-data" data-id=' . $row->id . ' data-toggle="modal" data-target="#editDataModal" title="Edit"><em class="fa fa-edit"></em></a>&nbsp;&nbsp;';
            $operate .= '<a class="btn btn-icon btn-sm btn-danger text-white delete-data" data-id=' . $row->id . ' data-image="' . $image . '"><em class="fa fa-trash"></em></a>';

            $tempRow['image_url'] = $image;
            $tempRow['id'] = $row->id;
            $tempRow['category_name'] = $row->category_name;
            $tempRow['image'] = (!empty($row->image)) ? '<a href=' . APP_URL . $image . '  data-toggle="lightbox" data-title="Image" data-gallery="gallery"><img src=' . APP_URL . $image . ' height=50, width=50 >' : 'No Image';
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

    public function users() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where = "where (id like '%" . $search . "%' OR name like '%" . $search . "%' OR email like '%" . $search . "%' OR mobile like '%" . $search . "%')";
        }
        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_users $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }
        $join = ' LEFT JOIN tbl_user_roles ur ON ur.id = u.role';

        $query1 = $this->db->query("SELECT u.*, ur.role, ur.id as role_id FROM tbl_users u $join $where  ORDER BY  $sort  $order  LIMIT  $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        $icon = array(
            'email' => 'far fa-envelope-open',
            'gmail' => 'fab fa-google-plus-square text-danger',
            'fb' => 'fab fa-facebook-square text-primary',
            'apple' => 'fab fa-apple',
            'mobile' => 'fas fa-phone-square',
        );
        foreach ($res1 as $row) {
            $operate = '<a class="btn btn-icon btn-sm btn-primary text-white edit-data" data-id=' . $row->id . ' data-toggle="modal" data-target="#editDataModal" title="Edit"><em class="fa fa-edit"></em></a>&nbsp;&nbsp;';

            if (filter_var($row->profile, FILTER_VALIDATE_URL) === FALSE) {
                // Not a valid URL. Its a image only or empty
                $profile = (!empty($row->profile)) ? APP_URL . 'public/images/profile/' . $row->profile : '';
            } else {
                /* if it is a ur than just pass url as it is */
                $profile = $row->profile;
            }

            $tempRow['status1'] = $row->status;
            $tempRow['id'] = $row->id;
            $tempRow['name'] = $row->name;
            $tempRow['email'] = $row->email;
            $tempRow['mobile'] = $row->mobile;
            $tempRow['type'] = (isset($row->type) && $row->type != '') ? '<em class="' . $icon[trim($row->type)] . ' fa-2x"></em>' : '<em class="' . $icon['email'] . ' fa-2x"></em>';
            $tempRow['profile'] = (!empty($row->profile)) ? '<a href=' . $profile . '  data-toggle="lightbox" data-title="Image" data-gallery="gallery"><img src=' . $profile . ' height=50, width=50 >' : 'No Image';
            $tempRow['status'] = ($row->status) ? "<span class='badge badge-success'>Active</span>" : "<span class='badge badge-danger'>Deactive</span>";
            $tempRow['date'] = date('d-M-Y h:i A', strtotime($row->date));
            $tempRow['role'] = $row->role;
            $tempRow['role_id'] = $row->role_id;
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

    public function comments() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = ' WHERE c.parent_id=0';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where .= " AND (c.id like '%" . $search . "%' OR c.message like '%" . $search . "%')";
        }

        $join = ' JOIN tbl_news n ON n.id = c.news_id';
        $join .= ' JOIN tbl_users u ON u.id = c.user_id';

        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_comment c $join $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT c.*, n.title, u.name FROM tbl_comment c $join $where  ORDER BY  $sort  $order  LIMIT  $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $operate = '<a class="btn btn-icon btn-sm btn-danger text-white delete-data" data-id=' . $row->id . ' ><em class="fa fa-trash"></em></a>';

            $tempRow['id'] = $row->id;
            $tempRow['user_id'] = $row->user_id;
            $tempRow['name'] = $row->name;
            $tempRow['title'] = $row->title;
            $tempRow['message'] = $row->message;
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

    public function comments_flag() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        $where = " WHERE cf.status=1";

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where .= " AND (cf.id like '%" . $search . "%' OR cf.message like '%" . $search . "%')";
        }

        $join = ' JOIN tbl_comment c ON c.id = cf.comment_id';
        $join .= ' JOIN tbl_news n ON n.id = cf.news_id';
        $join .= ' JOIN tbl_users u ON u.id = cf.user_id';

        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_comment_flag cf $join $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT cf.*,c.message as comment,n.title,u.name FROM tbl_comment_flag cf $join $where  ORDER BY  $sort  $order  LIMIT  $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $operate = '<a class="btn btn-icon btn-sm btn-warning text-white delete-comment" data-id=' . $row->comment_id . ' title="Delete Comment"><em class="fa fa-trash"></em></a>&nbsp;&nbsp;';
            $operate .= '<a class="btn btn-icon btn-sm btn-danger text-white delete-flag" data-id=' . $row->id . ' title="Delete flag"><em class="fa fa-trash"></em></a>';

            $tempRow['id'] = $row->id;
            $tempRow['comment_id'] = $row->comment_id;
            $tempRow['user_id'] = $row->user_id;
            $tempRow['news_id'] = $row->news_id;
            $tempRow['name'] = $row->name;
            $tempRow['message'] = $row->message;
            $tempRow['comment'] = $row->comment;
            $tempRow['title'] = $row->title;
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

    public function notification() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where = "where (tn.id like '%" . $search . "%' OR u.name like '%" . $search . "%' OR n.title like '%" . $search . "%')";
        }

        $join = ' LEFT JOIN tbl_category c ON tn.category_id=c.id';
        $join .= ' LEFT JOIN tbl_subcategory s ON tn.subcategory_id=s.id';
        $join .= ' LEFT JOIN tbl_news n ON tn.news_id=n.id';

        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_notifications tn $join $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT tn.*, c.category_name, s.subcategory_name, n.title as news_title FROM tbl_notifications tn $join $where  ORDER BY  $sort  $order  LIMIT  $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $image = (!empty($row->image)) ? 'public/images/notification/' . $row->image : '';
            $operate = '<a class="btn btn-icon btn-sm btn-danger text-white delete-data" data-id=' . $row->id . ' data-image="' . $image . '"><em class="fa fa-trash"></em></a>';

            $tempRow['id'] = $row->id;
            $tempRow['category_id'] = $row->category_id;
            $tempRow['category_name'] = ($row->category_name) ? $row->category_name : '';
            $tempRow['subcategory_id'] = $row->subcategory_id;
            $tempRow['subcategory_name'] = ($row->subcategory_name) ? $row->subcategory_name : '';
            $tempRow['news_title'] = ($row->news_title) ? $row->news_title : '';
            $tempRow['title'] = $row->title;
            $tempRow['message'] = $row->message;
            $tempRow['image'] = (!empty($row->image)) ? '<a href=' . APP_URL . $image . '  data-toggle="lightbox" data-title="Image" data-gallery="gallery"><img src=' . APP_URL . $image . ' height=50, width=50 >' : 'No Image';
            $tempRow['date'] = date('d-M-Y h:i A', strtotime($row->date_sent));
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

    public function news() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

            $where = " WHERE n.title IS NOT NULL";
        
            if ($this->request->getVar('category')) {
                $category = $this->request->getVar('category');
                $where .= " AND n.category_id=" . $category;
                if ($this->request->getVar('subcategory')) {
                    $subcategory = $this->request->getVar('subcategory');
                    $where .= " AND n.subcategory_id=" . $subcategory;
                }
            }
            if ($this->request->getVar('user')) {
                $user = $this->request->getVar('user');
                $where .= " AND n.user_id=" . $user;
               
            }
            if ($this->request->getVar('role')) {
                $role = $this->request->getVar('role');
                $where .= " AND u.role=" . $role;
               
            }
            if ($this->request->getVar('status') OR  $this->request->getVar('status')=='0') {
                $status = $this->request->getVar('status');
                $where .= " AND n.status=" . $status;
               
            }
    

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where = " WHERE (n.id like '%" . $search . "%' OR c.category_name like '%" . $search . "%' OR n.title like '%" . $search . "%')";
            if ($this->request->getVar('category')) {
                $category = $this->request->getVar('category');
                $where .= " AND n.category_id=" . $category;
                if ($this->request->getVar('subcategory')) {
                    $subcategory = $this->request->getVar('subcategory');
                    $where .= " AND n.subcategory_id=" . $subcategory;
                }
                if ($this->request->getVar('user')) {
                    $user = $this->request->getVar('user');
                    $where .= " AND n.user_id=" . $user;
                   
                }
            }
        }

        $join = ' LEFT JOIN tbl_category c ON c.id = n.category_id';
        $join .= ' LEFT JOIN tbl_subcategory s ON s.id = n.subcategory_id';
        $join .= ' LEFT JOIN tbl_users u ON u.id = n.user_id';

        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_news n $join $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT n.*, c.category_name, s.subcategory_name, u.name FROM tbl_news n $join $where  ORDER BY  $sort  $order  LIMIT  $offset , $limit");
        $res1 = $query1->getResult();
        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $con_v = '';
            $image = (!empty($row->image)) ? 'public/images/news/' . $row->image : '';
            $operate = '<a class="btn btn-icon btn-sm btn-success text-white edit-data-des" data-id=' . $row->id . ' data-toggle="modal" data-target="#editDataDesModal" title="Description"><em class="fa fa-eye"></em></a>&nbsp;&nbsp;';
            if ($row->content_type != 'standard_post') {
                if ($row->content_type == 'video_upload') {
                    $con_value = 'public/images/news_video/' . $row->content_value;
                    $con_v = 'public/images/news_video/' . $row->content_value;
                    $operate .= '<a class="btn btn-icon btn-sm btn-warning text-white" data-toggle="lightbox" data-title="Video" data-type="video" href="' . $con_value . '" title="view video"><em class="fas fa-eye"></em></a>&nbsp;&nbsp;';
                } else {
                    $con_value = $row->content_value;
                    $con_v = '';
                    $operate .= '<a class="btn btn-icon btn-sm btn-warning text-white" data-toggle="lightbox" data-title="Video" data-type="youtube" href="' . $con_value . '" title="view video"><em class="fas fa-eye"></em></a>&nbsp;&nbsp;';
                }
            }
            $operate .= '<a class="btn btn-icon btn-sm btn-primary text-white edit-data" data-id=' . $row->id . ' data-toggle="modal" data-target="#editDataModal" title="Edit"><em class="fa fa-edit"></em></a>&nbsp;&nbsp;';
            $operate .= '<a class="btn btn-icon btn-sm btn-danger text-white delete-data" data-id=' . $row->id . ' data-image="' . $image . '" data-cvalue="' . $con_v . '"><em class="fa fa-trash"></em></a>';

            $total_image = $this->db->table('tbl_news_image')->where('news_id', $row->id)->countAllResults();

            $query2 = $this->db->query('SELECT GROUP_CONCAT(distinct(tag_name)) as tag_name FROM tbl_tag WHERE id IN(' . $row->tag_id . ')');
            $res2 = $query2->getResult();
            $tag_name = (!empty($res2)) ? $res2[0]->tag_name : '';

            $tempRow['con_v'] = $con_v;
            $tempRow['content_value'] = $con_value;
            $tempRow['image_url'] = $image;
            $tempRow['date1'] = $row->date;
            $tempRow['content'] = $row->content_type;
            $tempRow['id'] = $row->id;
            $tempRow['category_id'] = $row->category_id;
            $tempRow['category_name'] = ($row->category_name) ? $row->category_name : '';
            $tempRow['subcategory_id'] = $row->subcategory_id;
            $tempRow['subcategory_name'] = ($row->subcategory_name) ? $row->subcategory_name : '';
            $tempRow['tag_id'] = $row->tag_id;
            $tempRow['tag_name'] = $tag_name;
            $tempRow['title'] = $row->title;
            $tempRow['content_type'] = str_replace('_', ' ', $row->content_type);
            $tempRow['image'] = (!empty($row->image)) ? '<a href=' . APP_URL . $image . '  data-toggle="lightbox" data-title="Image" data-gallery="gallery"><img src=' . APP_URL . $image . ' height=50, width=50 >' : 'No Image';
            $tempRow['description'] = $row->description;
            $tempRow['date'] = date('d-M-Y', strtotime($row->date));
            $tempRow['total_image'] = '<a href=' . APP_URL . "news-image/" . $row->id . ' class="btn btn-icon btn-sm btn-warning" title="other image">' . $total_image . '</a>';
            $tempRow['user'] = ($row->name) ? $row->name : '-';
            $tempRow['show_till'] = $row->show_till;
            $tempRow['status'] = is_news_status($row->status);
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

    public function newsImage() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        $news_id = $this->request->getVar('news_id');
        $where = " WHERE tni.news_id='" . $news_id . "' ";

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where .= " AND (tni.id like '%" . $search . "%' OR  OR tn.title like '%" . $search . "%')";
        }

        $join = ' JOIN tbl_news tn ON tn.id = tni.news_id';

        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_news_image tni $join $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT tni.*, tn.title FROM tbl_news_image tni $join $where  ORDER BY  $sort  $order  LIMIT  $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $image = (!empty($row->other_image)) ? 'public/images/news/' . $row->news_id . '/' . $row->other_image : '';
            $operate = '<a class="btn btn-icon btn-sm btn-danger text-white delete-data" data-id=' . $row->id . ' data-image="' . $image . '"><em class="fa fa-trash"></em></a>';

            $tempRow['image_url'] = $image;
            $tempRow['id'] = $row->id;
            $tempRow['news_id'] = $row->news_id;
            $tempRow['title'] = $row->title;
            $tempRow['image'] = (!empty($image)) ? '<a href=' . APP_URL . $image . '  data-toggle="lightbox" data-title="Image" data-gallery="gallery"><img src=' . APP_URL . $image . ' height=50, width=50 >' : 'No Image';
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

    public function survey() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where = "where (id like '%" . $search . "%' OR question like '%" . $search . "%')";
        }

        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_survey_question $where ");
        $res = $query->getResult();
        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT * FROM tbl_survey_question $where ORDER BY $sort $order LIMIT $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $operate = '<a href="survey_option/' . $row->id . '" class="btn btn-icon btn-sm btn-success text-white view-data" data-id=' . $row->id . ' title="View"><em class="fa fa-eye"></em></a>&nbsp;&nbsp;';
            $operate .= '<a class="btn btn-icon btn-sm btn-primary text-white edit-data" data-id=' . $row->id . ' data-toggle="modal" data-target="#editDataModal" title="Edit"><em class="fa fa-edit"></em></a>&nbsp;&nbsp;';
            $operate .= '<a class="btn btn-icon btn-sm btn-danger text-white delete-data" data-id=' . $row->id . ' title="Delete"><em class="fa fa-trash"></em></a>';

             $total_ans = $this->db->table('tbl_survey_result')->where('question_id', $row->id)->get()->getResult();
            
            
            $tempRow['id'] = $row->id;
            $tempRow['question'] = $row->question;
            $tempRow['status'] = ($row->status) ? "<span class='badge badge-success'>Enable</span>" : "<span class='badge badge-danger'>Disable</span>";
            $tempRow['counter'] = count($total_ans);
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

    public function surveyoption() {
        $offset = 0;
        $limit = 10;
        $sort = 'id';
        $order = 'DESC';
        $where = '';

        if ($this->request->getVar('offset'))
            $offset = $this->request->getVar('offset');
        if ($this->request->getVar('limit'))
            $limit = $this->request->getVar('limit');

        if ($this->request->getVar('sort'))
            $sort = $this->request->getVar('sort');
        if ($this->request->getVar('order'))
            $order = $this->request->getVar('order');

        $question_id = $this->request->getVar('question_id');
        $where = " WHERE tbl_survey_option.question_id='" . $question_id . "' ";

        if ($this->request->getVar('search')) {
            $search = $this->request->getVar('search');
            $where .= " AND (tbl_survey_option.options like '%" . $search . "%')";
        }

        $join = ' JOIN tbl_survey_question ON tbl_survey_question.id = tbl_survey_option.question_id';

        $query = $this->db->query("SELECT COUNT(*) as total FROM tbl_survey_option $join $where ");
        $res = $query->getResult();

        foreach ($res as $row1) {
            $total = $row1->total;
        }

        $query1 = $this->db->query("SELECT tbl_survey_option.*, tbl_survey_question.question, tbl_survey_question.id as question_id FROM tbl_survey_option  $join $where  ORDER BY  $sort  $order  LIMIT  $offset , $limit");
        $res1 = $query1->getResult();

        $bulkData = array();
        $bulkData['total'] = $total;
        $rows = array();
        $tempRow = array();
        $count = 1;
        foreach ($res1 as $row) {
            $operate = '<a class="btn btn-icon btn-sm btn-primary text-white edit-data" data-id=' . $row->id . ' data-toggle="modal" data-target="#editDataModal" title="Edit"><em class="fa fa-edit"></em></a>&nbsp;&nbsp;';
            $operate .= '<a class="btn btn-icon btn-sm btn-danger text-white delete-data" data-id=' . $row->id . ' title="Delete"><em class="fa fa-trash"></em></a>';

            $get_user = $this->db->table('tbl_survey_result')->where('question_id', $question_id)->get()->getResult();
            $per='0';
            if($get_user)
            {
                $total_user = count($get_user);
                $per = $row->counter * 100 / $total_user;
            }
            
           
            $tempRow['id'] = $row->id;
            $tempRow['question'] = $row->question;
            $tempRow['question_id'] = $question_id;
            $tempRow['counter'] = ($row->counter) ? ($row->counter) : '0';
            $tempRow['options'] = $row->options;
            $tempRow['percentage'] = ($per)?(round($per,2).' %'):'0 %';
            $tempRow['operate'] = $operate;
            $rows[] = $tempRow;
            $count++;
        }

        $bulkData['rows'] = $rows;
        echo json_encode($bulkData, JSON_UNESCAPED_UNICODE);
    }

}

?>